package com.tappli.android.asynctaskbug;

import android.app.Activity;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;

public class MainActivity extends Activity {
	private static final String TAG = "AsyncTaskBug";
	
	private BugTestTask mTask = null;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		
		Log.v(TAG, "Activity.onCreate:");
		mTask = new BugTestTask();
		mTask.execute();
	}
	
	@Override
	protected void onPause() {
		super.onPause();
		
		Log.v(TAG, "Activity.onPause:");
//		if (mTask != null) {
//			mTask.cancel(false);
//			mTask = null;
//		}
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
		
		Log.v(TAG, "Activity.onDestroy:");
		if (mTask != null) {
			mTask.cancel(false);
			mTask = null;
		}
	}

	private class BugTestTask extends AsyncTask<String, Integer, Integer> {
		@Override
		protected Integer doInBackground(String... params) {
			int i = 0;
			// キャンセルされるまで待つ
			while (!isCancelled()) {
				try {
					Thread.sleep(1000);
					
					publishProgress(i++);
				}
				catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
			return null;
		}

		@Override
		protected void onPreExecute() {
			super.onPreExecute();
			
			Log.v(TAG, "onPreExecute:");
		}

		@Override
		protected void onProgressUpdate(Integer... values) {
			super.onProgressUpdate(values);
			
			Log.v(TAG, "onProgressUpdate:" + values[0]);
		}

		@Override
		protected void onCancelled() {
			super.onCancelled();
			
			Log.v(TAG, "onCancelled");
		}

		@Override
		protected void onPostExecute(Integer result) {
			super.onPostExecute(result);
			
			Log.v(TAG, "onPostExcecute:" + result);
		}
	}
}